
package de.ivu.elect.presentation.gebietsbaum.exchange;

import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.exchange.control.AbstractImporter;
import de.ivu.elect.business.gebietsbaum.boundary.GebietChangeEvent;
import de.ivu.elect.business.gebietsbaum.boundary.GebietsartExtendedDAO;
import de.ivu.elect.business.gebietsbaum.boundary.GebietsbaumStimmbezirkImporter;
import de.ivu.elect.business.gebietsbaum.control.Gebietsbaum;
import de.ivu.elect.business.gebietsbaum.control.StimmbezirkGebietsbaumExchangeContext;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.jee.presentation.redirect.Redirect;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.exchange.AbstractImportBestaetigenView;
import de.ivu.elect.presentation.exchange.ImportDescription;
import de.ivu.elect.presentation.gebietsbaum.SetzeWurzelgebietSelectChangeListener;

@Named(GebietStimmbezirkImportBestaetigenView.COMPONENT_NAME)
@View(viewId = GebietStimmbezirkImportBestaetigenView.VIEW_ID, useCase = UseCasePermission.GEBIET_STIMMBEZIRKE_IMPORTIEREN)
public class GebietStimmbezirkImportBestaetigenView
    extends
      AbstractImportBestaetigenView<Gebietsbaum, StimmbezirkGebietsbaumExchangeContext> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "gebietStimmbezirkImportBestaetigenView";

  public static final String VIEW_ID = "/gebietsbaum/gebiet-stimmbezirk-import-bestaetigen.xhtml";

  @Inject
  private transient GebietsbaumStimmbezirkImporter gebietsbaumImporter;

  @Inject
  private transient GebietStimmbezirkImportDescription gebietImportDescription;

  @Inject
  private transient SetzeWurzelgebietSelectChangeListener setzeWurzelgebietWahlSelectChangeListener;

  @Inject
  private transient GebietsartExtendedDAO gebietsartExtendedDAO;

  @Inject
  private transient GebietChangeEvent gebietChangeEvent;

  public GebietStimmbezirkImportBestaetigenView() {
    super();
  }

  @Override
  protected AbstractImporter<Gebietsbaum, StimmbezirkGebietsbaumExchangeContext, ? > getImporter() {
    return gebietsbaumImporter;
  }

  private StimmbezirkGebietsbaumExchangeContext context;

  @Override
  protected StimmbezirkGebietsbaumExchangeContext getContext() {
    if (context == null) {
      context = new StimmbezirkGebietsbaumExchangeContext(getSelectedWahl(),
        gebietsartExtendedDAO.findByGebieteInWahlVorhanden(getSelectedWahl()));
    }
    return context;
  }

  @Override
  protected ImportDescription getImportDescription() {
    return gebietImportDescription;
  }

  @Override
  @Redirect
  public String importieren() {
    String result = super.importieren();
    setzeWurzelgebietWahlSelectChangeListener.setzeWurzelgebiet(getSelectedWahl());
    gebietChangeEvent.sendChangeEvent(); // Gebietsbaum neu laden
    return result;
  }
}
